% berechnet des Quadrat einer Binaerzahl
% Autor: Heiner Grote

$ALPHABET{10}
$BLANK{b}
$TAPE{10101010}
$OUT{}

{R % faehrt nach rechts bis ein blank kommt 
:start
.r       
#b>start
}

{Rb % faehrt nach rechts bis ein Zeichen != blank kommt 
:start
.r       
=b>start
}

{L % faehrt nach links bis ein blank kommt
:start
.l 
#b>start
}

{Lb % faehrt nach links bis ein Zeichen != blank kommt 
:start
.l       
=b>start
}



{DEL % loescht das Wort auf dem der Kopf grade steht
 
  .R

  :loop
  .l
  =b>ende
  b 
  >loop
  
  :ende

}


{Kopier % Kopiermaschine, Kopie steht hinter der Eingabe  
.L
:start
.r
=b>ende
=0>start0 % eine 0 kopieren
=1>start1 % eine 1 kopieren
:start0
b .R .R 0 .L .L 0
>start
:start1
b .R .R 1 .L .L 1
>start
:ende
.R
}

{Kopier2 % Kopiermaschine 2, Kopie steht vor der Eingabe  

  .R      % ans Ende des Wortes fahren
  :start  
  .l      % nach links
  =b>ende
  =0>start0 % eine 0 kopieren
  =1>start1 % eine 1 kopieren
  :start0
  b .L .L 0 .R .R 0
  >start
  :start1
  b .L .L 1 .R .R 1
  >start
  :ende
  .L
}



{DEC % dekrementiert eine binaerzahl

  .R  % nach Rechts
  .l  % auf letzte Ziffer

  :loop
  =1>found1  % 1 gefunden
  =0>found0  % 0 gefunden    
  =b>ende    % blank  

  :found0 
  1           % 1 schreiben
  .l          % nach links
  >loop

  :found1
  0           % 0 schreiben und fertig

  :ende
}

{INC % inkrementiert eine binaerzahl

  .R  % nach Rechts
  .l  % auf letzte Ziffer

  :loop
  =1>found1  % 1 gefunden
  =0>found0  % 0 gefunden    
  =b>ende    % blank  


  :found1 
  0           % 0 schreiben
  .l          % nach links
  =b>carry    % wenn Zahl zuende, carry vorne dran
  >loop       % sonnst carry addieren
  
  :carry
  1
  >ende

  :found0
  1           % 0 schreiben und fertig

  :ende
}


{ADD % Addition zweier binaerzahlen 
     % in:  bb<x>xxxbyyyybb  xx,yy Zahlen die addiert werden solle 
     % out: bb<z>zzzzzbbb    zz Summe

  :loop
  .R
  .r       % zum Start der zweiten Zahl
  
  :eq0loop
  =1>neq0   % 1 gefunden: zahl != 0
  =b>eq0    % blank: zahl ist 0
  .r        % nach rechts und weiter
  >eq0loop
  
  :eq0      % zweite Zahl war 0
  .l        % nach links ins Wort 
  .DEL      % loeschen
  .Lb .L .r % zum anfang der summe
  >ende     % und fertig
    
  :neq0
  .DEC      % die zweite Zahl runterzaehlen
  .L .Lb    % zur ersten Zahl
  .INC      % diese hochzaehlen

  >loop      % und weiter

  :ende

}


{MUL % Multiplikation zweier binaerzahlen 
     % in:  bb<x>xxxbyyyybb  xx,yy Zahlen die multipliziert werden sollen 
     % out: bb<z>zzzzzbbb    zzz Ergebnis


  .Kopier2  % erste Zahl zweimal vor die Eingabe kopieren
  .Rb
  .Kopier2
  
  .Rb .R    % Zur letzten Zahl fahren
  .Rb .R 
  .Rb .R 
  .Rb     

  :loop

  .DEC
  .L .r
  :eq0loop  % Test, ob diese Null ist
  =1>neq0   % 1 gefunden: zahl != 0
  =b>eq0    % blank: zahl ist 0
  .r        % nach rechts und weiter
  >eq0loop
  
  :eq0      % Zahl war 0: aufraeumen

  .l        % nach links ins Wort
  .DEL      % loeschen
  .Lb       % Faktor1 loeschen      
  .DEL      
  .Lb       % Kopierte Zahl loeschen
  .DEL      
  .Lb
  .L .r 
  >ende  
 
  :neq0     % Zahl noch nicht null
  
  .L .Lb .L .Lb .L .Lb .L .r % ganz nach links
     
  .ADD      % die ersten beiden Zahlen addieren
  .R .Rb    % zur gemerkten Zahl fahren
  .Kopier2  % wieder kopieren
  .Rb .R .Rb .R .Rb % zur letzten Zahl fahren 
  >loop  

  :ende
}


{QUADRAT % berechnet eingabe^2

  .Kopier
  .Lb .L .Lb .L .r
  .MUL

}


% jetzt kommt das 'Hauptprogramm'
.QUADRAT
