% Dezimal-Multiplizierer
% Eingabe <x>xxxbyyyy mit x,y:Faktoren beliebiger Laenge, b: Blank 
% Ausgabe x*y

% Autor: Heiner Grote

$ALPHABET{0123456789}
$BLANK{b}
$TAPE{32b43}
$OUT{dezmulout}

{R % faehrt nach rechts bis ein blank kommt 
:start
.r       
#b>start
}

{Rb % faehrt nach rechts bis ein Zeichen != blank kommt 
:start
.r       
=b>start
}

{L % faehrt nach links bis ein blank kommt
:start
.l 
#b>start
}

{Lb % faehrt nach links bis ein Zeichen != blank kommt 
:start
.l       
=b>start
}

{DEL % loescht das Wort auf dem der Kopf grade steht
 
  .R

  :loop
  .l =b>ende b 
  >loop
  
  :ende
}

{Kopier2 % Kopiermaschine 2, Kopie steht vor der Eingabe  

  .R      % ans Ende des Wortes fahren
  :start  
  .l      % nach links
  =b>ende

  =0>start0 % eine 0 kopieren
  =1>start1 % eine 1 kopieren
  =2>start2 % eine 2 kopieren
  =3>start3 % eine 3 kopieren
  =4>start4 % eine 4 kopieren
  =5>start5 % eine 5 kopieren
  =6>start6 % eine 6 kopieren
  =7>start7 % eine 7 kopieren
  =8>start8 % eine 8 kopieren
  =9>start9 % eine 9 kopieren

  :start0 b .L .L 0 .R .R 0 >start
  :start1 b .L .L 1 .R .R 1 >start
  :start2 b .L .L 2 .R .R 2 >start
  :start3 b .L .L 3 .R .R 3 >start
  :start4 b .L .L 4 .R .R 4 >start
  :start5 b .L .L 5 .R .R 5 >start
  :start6 b .L .L 6 .R .R 6 >start
  :start7 b .L .L 7 .R .R 7 >start
  :start8 b .L .L 8 .R .R 8 >start
  :start9 b .L .L 9 .R .R 9 >start

  :ende
  .L
}


{DEC % dekrementiert eine Dezimalzahl
     % am ende steht der Kopf eine Pos. vor der Zahl 

  .R  % nach Rechts
  .l  % auf letzte Ziffer

  :loop
  =0>found0  % 0 gefunden    
  =1>found1  % 1 gefunden
  =2>found2  % 2 gefunden    
  =3>found3  % 3 gefunden
  =4>found4  % 4 gefunden    
  =5>found5  % 5 gefunden
  =6>found6  % 6 gefunden    
  =7>found7  % 7 gefunden
  =8>found8  % 8 gefunden    
  =9>found9  % 9 gefunden
  =b>ende    % blank  

  :found0 
  9           % 9 schreiben
  .l          % nach links
  >loop

  :found1 0 .L >ende
  :found2 1 .L >ende
  :found3 2 .L >ende
  :found4 3 .L >ende
  :found5 4 .L >ende
  :found6 5 .L >ende
  :found7 6 .L >ende
  :found8 7 .L >ende
  :found9 8 .L >ende
 
  :ende
}

{INC % inkrementiert eine Dezimalzahl

  .R  % nach Rechts
  .l  % auf letzte Ziffer

  :loop
  =0>found0  % 0 gefunden    
  =1>found1  % 1 gefunden
  =2>found2  % 2 gefunden    
  =3>found3  % 3 gefunden
  =4>found4  % 4 gefunden    
  =5>found5  % 5 gefunden
  =6>found6  % 6 gefunden    
  =7>found7  % 7 gefunden
  =8>found8  % 8 gefunden    
  =9>found9  % 9 gefunden
  =b>ende    % blank  


  :found9 
  0           % 0 schreiben
  .l          % nach links
  =b>carry    % wenn Zahl zuende, carry vorne dran
  >loop       % sonnst carry addieren
  
  :carry
  1
  >ende

  :found0 1 .L >ende
  :found1 2 .L >ende
  :found2 3 .L >ende
  :found3 4 .L >ende
  :found4 5 .L >ende
  :found5 6 .L >ende
  :found6 7 .L >ende
  :found7 8 .L >ende
  :found8 9 .L >ende
  
  :ende
}


{ADD % Addition zweier Zahlen 
     % in:  bb<x>xxxbyyyybb  xx,yy Zahlen die addiert werden solle 
     % out: bb<z>zzzzzbbb    zz Summe

  :loop
  .R
  .r       % zum Start der zweiten Zahl
  
  :eq0loop
  =0>next   % 0 gefunden: naechste pruefen
  =b>eq0    % blank: zahl ist 0
  >neq0     % andere Ziffer: zahl != 0
  :next
  .r        % nach rechts und weiter
  >eq0loop
  
  :eq0      % zweite Zahl war 0
  .l        % nach links ins Wort 
  .DEL      % loeschen
  .Lb .L .r % zum anfang der summe
  >ende     % und fertig
    
  :neq0
  .DEC      % die zweite Zahl runterzaehlen
  .Lb       % zur ersten Zahl
  .INC      % diese hochzaehlen

  .r
  >loop      % und weiter

  :ende
}

{MUL % Multiplikation zweier Zahlen 
     % in:  bb<x>xxxbyyyybb  xx,yy Zahlen die multipliziert werden sollen 
     % out: bb<z>zzzzzbbb    zzz Ergebnis

  .Kopier2  % erste Zahl zweimal vor die Eingabe kopieren
  .Rb
  .Kopier2
  
  .Rb .R    % Zur letzten Zahl fahren
  .Rb .R 
  .Rb .R 
  .Rb     

  :loop

  .DEC
  .r
  :eq0loop  % Test, ob diese Null ist
  =0>next   % 0: neachste Stelle pruefen
  =b>eq0    % blank: zahl ist 0
  >neq0     % ander Ziffer: Zahl != 0
  :next
  .r        % nach rechts und weiter
  >eq0loop
  
  :eq0      % Zahl war 0: aufraeumen

  .l        % nach links ins Wort
  .DEL      % loeschen
  .Lb       % Faktor1 loeschen      
  .DEL      
  .Lb       % Kopierte Zahl loeschen
  .DEL      
  .Lb
  .L .r 
  >ende  
 
  :neq0     % Zahl noch nicht null
  
  .L .Lb .L .Lb .L .Lb .L .r % ganz nach links
     
  .ADD      % die ersten beiden Zahlen addieren
  .R .Rb    % zur gemerkten Zahl fahren
  .Kopier2  % wieder kopieren
  .Rb .R .Rb .R .Rb % zur letzten Zahl fahren 
  >loop  

  :ende
}

% jetzt kommt das 'Hauptprogramm'
.MUL
